=== debian/changelog ===
uftrace (0.6.0.20161014-1) unstable; urgency=low

  * Initial packaging of git snapshot at commit 06e6740256 (closes: #839877).

 -- paul cannon <pik@debian.org>  Fri, 14 Oct 2016 10:55:12 -0500
