=== debian/watch ===
# project does not yet have an established release plan; maintainer is expected
# either to coordinate with upstream or to test the current master branch head
# somewhat thoroughly before using a new upstream version.
