## uftrace 0.6.2

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION := 0.6
+VERSION := 0.6.2
 
 # Makefiles suck: This macro sets a default value of $(2) for the
 # variable named by $(1), unless the variable has been set by
@@ -82,8 +82,11 @@
 
 all:
 
-include $(srcdir)/config/Makefile
-include $(srcdir)/config/Makefile.include
+ifneq ($(wildcard $(srcdir)/check-deps/check-tstamp),)
+  include $(srcdir)/check-deps/Makefile.check
+endif
+
+include $(srcdir)/Makefile.include
 
 
 LIBMCOUNT_TARGETS := libmcount/libmcount.so libmcount/libmcount-fast.so
@@ -98,7 +101,7 @@
 UFTRACE_SRCS += $(wildcard $(srcdir)/arch/$(ARCH)/regs.c)
 UFTRACE_OBJS := $(patsubst $(srcdir)/%.c,$(objdir)/%.o,$(UFTRACE_SRCS))
 
-UFTRACE_HDRS := $(wildcard $(srcdir)/*.h $(srcdir)/utils/*.h)
+UFTRACE_HDRS := $(filter-out $(srcdir)/version.h,$(wildcard $(srcdir)/*.h $(srcdir)/utils/*.h))
 UFTRACE_HDRS += $(srcdir)/libmcount/mcount.h
 
 LIBMCOUNT_SRCS := $(filter-out %-nop.c,$(wildcard $(srcdir)/libmcount/*.c))
@@ -174,6 +177,10 @@
 
 $(objdir)/.config: $(srcdir)/configure
 	$(QUIET_GEN)$(srcdir)/configure -o $@ $(MAKEOVERRIDES)
+	@$(MAKE) -C $(objdir)
+# The above recursive make will handle all build procedure with
+# updated dependency.  So just abort the current build.
+	$(error)
 
 config: $(srcdir)/configure
 	$(QUIET_GEN)$(srcdir)/configure -o $(objdir)/.config $(MAKEOVERRIDES)
@@ -211,7 +218,7 @@
 $(objdir)/libmcount/libmcount-fast-single.so: $(LIBMCOUNT_FAST_SINGLE_OBJS) $(objdir)/arch/$(ARCH)/entry.op
 	$(QUIET_LINK)$(CC) -shared -o $@ $^ $(LIB_LDFLAGS)
 
-$(objdir)/libtraceevent/libtraceevent.a: PHONY
+$(objdir)/libtraceevent/libtraceevent.a: $(wildcard $(srcdir)/libtraceevent/*.[ch]) $(objdir)/.config
 	@$(MAKE) -C $(srcdir)/libtraceevent BUILD_SRC=$(srcdir)/libtraceevent BUILD_OUTPUT=$(objdir)/libtraceevent CONFIG_FLAGS="$(TRACEEVENT_CFLAGS)"
 
 $(objdir)/uftrace.o: $(srcdir)/uftrace.c $(objdir)/version.h $(COMMON_DEPS)
@@ -265,9 +272,3 @@
 
 clean:
 	$(call QUIET_CLEAN, uftrace)
-	$(Q)$(RM) $(objdir)/*.o $(objdir)/*.op $(objdir)/*.so $(objdir)/*.a
-	$(Q)$(RM) $(objdir)/utils/*.o $(objdir)/utils/*.op $(objdir)/libmcount/*.op
-	$(Q)$(RM) $(objdir)/gmon.out $(TARGETS)
-	$(Q)$(RM) $(objdir)/uftrace-*.tar.gz $(objdir)/version.h
-	@$(MAKE) -sC $(srcdir)/arch/$(ARCH) clean
-	@$(MAKE) -sC $(srcdir)/tests ARCH=$(ARCH) clean
