=== doc/Makefile ===
--- 
+++ 
@@ -5,7 +5,7 @@
 RM := rm -f
 INSTALL = install
 
-include ../config/Makefile.include
+include ../Makefile.include
 
 COMMANDS = record replay live report recv info dump graph
 MANPAGES = uftrace.1 $(patsubst %,uftrace-%.1,$(COMMANDS))
