=== arch/arm/Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 sdir = $(srcdir)/arch/arm
 odir = $(objdir)/arch/arm
 
-include $(srcdir)/config/Makefile.include
+include $(srcdir)/Makefile.include
 
 ARCH_ENTRY_SRC = $(wildcard $(sdir)/*.S)
